#line 1 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
#line 1 "c:/users/richard/desktop/workdir/thermo_k/example/pic/mcp9600.h"
#line 3 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

sbit LCD_BCK at LATG3_bit;
sbit LCD_BCK_Direction at TRISG3_bit;

char tk_status;
char txt[10];
char lab1[10];
char old_txt[10];
char tmp_data[10];
char Temp_Data_Ready;
#line 34 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
char Write_MCP9600_Data(char RegAddr, char _data)
{
 tmp_data[0] = RegAddr;
 tmp_data[1] = _data;

 I2C1_Start();
 I2C1_Wr(  0xC0  );
 I2C1_Wr( tmp_data[ 0 ] );
 I2C1_Wr( tmp_data[ 1 ] );
 I2C1_Stop();
}
#line 53 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
char Read_MCP9600_Data( char RegAddr )
{
 tmp_data[0] = RegAddr;

 I2C1_Start();
 I2C1_Wr(  0xC0  );
 I2C1_Wr( tmp_data[ 0 ] );
 I2C1_Stop();
 Delay_us( 50 );
 I2C1_Start();
 I2C1_Wr(  0xC0  | 1 );
 tmp_data[ 0 ] = I2C1_Rd( 0 );
 I2C1_Stop();

 return tmp_data[0];
}
#line 77 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
char Read_MCP9600_Status()
{
 char DataSum;

 tmp_data[0] =  0x04 ;

 I2C1_Start();
 I2C1_Wr(  0xC0  );
 I2C1_Wr( tmp_data[ 0 ] );
 I2C1_Stop();
 Delay_us( 50 );
 I2C1_Start();
 I2C1_Wr(  0xC0  | 1 );
 tmp_data[ 0 ] = I2C1_Rd( 0 );
 I2C1_Stop();
 DataSum = tmp_data[0];

 return DataSum;
}
#line 104 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
float Read_Temperature()
{
 float Temperature;

 tmp_data[0] =  0x00 ;

 I2C1_Start();
 I2C1_Wr(  0xC0  );
 I2C1_Wr( tmp_data[ 0 ] );
 I2C1_Stop();
 Delay_us( 50 );
 I2C1_Start();
 I2C1_Wr(  0xC0  | 1 );
 tmp_data[ 0 ] = I2C1_Rd( 1 );
 tmp_data[ 1 ] = I2C1_Rd( 0 );
 I2C1_Stop();

 if((tmp_data[0] & 0x80) == 0x80){
 tmp_data[0] = tmp_data[0] & 0x7F;
 Temperature = 1024 - (tmp_data[0]*16 + tmp_data[1] / 16);
 }
 else
 Temperature = (tmp_data[0] * 16 + (float)tmp_data[1] / 16);

 return Temperature;
}
#line 138 "C:/Users/richard/Desktop/WORKDIR/Thermo_K/example/PIC/Thermo_K_PIC.c"
void updateLabel(char *newText, int x, int y, char* lbl)
{
 Lcd_Out( 2, 5, newText );
}




void main()
{
 char res;

 ANCON0 = 0;
 ANCON1 = 0;
 ANCON2 = 0;
 LCD_BCK_Direction = 0;
 LCD_BCK = 1;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out( 1, 2, "Thermo K click" );
 I2C1_Init( 100000 );
 Delay_ms( 200 );

 while(1){
 tk_status = &Read_MCP9600_Status;
 Temp_Data_Ready = ( tk_status & 0x40 );

 if (Temp_Data_Ready){
 sprintf(txt, "%2.1f C", Read_Temperature());
 res = strcmp(txt,old_txt);

 if(res != 0){
 updateLabel(txt, 135, 90, lab1);
 strcpy(old_txt,txt);
 }
 }
 Delay_ms(500);
 }
}
